## mingw-w64-skia-108.0.5359.95-4.src.tar.zst

=== bazel/Makefile ===
EXPORTER_TOOL=bazel-bin/bazel/exporter_tool/exporter_tool_/exporter_tool
EXPORTER_RULES=-rule='//src/...' -rule='//modules/...' -rule='//include/...'

generate:
	echo "You do not need to run this any more for C++ code, only if you modify go code"

generate_go:
	cd .. && bazelisk run //:gazelle -- update infra/bots/task_drivers modules/canvaskit/go bazel/exporter

.PHONY: generate_cmake
generate_cmake:
	cd .. && bazelisk build //bazel/exporter_tool && ${EXPORTER_TOOL} \
		-output_format=cmake -proj_name=Skia -rule='//:skia_public'

.PHONY: generate_gni
generate_gni:
	cd .. && bazelisk build //bazel/exporter_tool && ${EXPORTER_TOOL} \
		-output_format=gni -proj_name=Skia ${EXPORTER_RULES} \
		&& bin/gn format gn/*.gni modules/*/*.gni

.PHONY: check_gni
check_gni:
	cd .. && bazelisk build //bazel/exporter_tool && ${EXPORTER_TOOL} \
		-output_format=gni -proj_name=Skia ${EXPORTER_RULES} -check_current

.PHONY: mocks
mocks:
	go generate ./...

# This target should be run after the go.mod file is updated (e.g. version rolls or new updates)
gazelle_update_repo:
	cd .. && bazelisk run //:gazelle -- update-repos -from_file=go.mod -to_macro=go_repositories.bzl%go_repositories

# Run this target to test all known working Bazel builds
known_good_builds:
	bazelisk build //:skia_public
	bazelisk build //:skia_internal
	bazelisk build //experimental/bazel_test/...
	bazelisk run //experimental/bazel_test:bazel_test_exe
	bazelisk build //example:hello_world_gl
	bazelisk build //example:hello_world_vulkan
	bazelisk build //example:hello_world_dawn
	bazelisk build //example:vulkan_basic
	bazelisk build //src/sksl/lex:sksllex
	bazelisk build //tools/skdiff
	bazelisk build //tools/skslc
	bazelisk build //modules/skottie:skottie_tool_cpu
	bazelisk build //modules/skottie:skottie_tool_gpu
	bazelisk build //modules/canvaskit:canvaskit --config=ck_full_webgl2_release

rbe_known_good_builds:
	bazelisk build //:skia_public --config=for_linux_x64_with_rbe --remote_download_minimal
	bazelisk build //:skia_internal --config=for_linux_x64_with_rbe --remote_download_minimal
	bazelisk build //experimental/bazel_test:bazel_test_exe --config=for_linux_x64_with_rbe --remote_download_minimal
	bazelisk build //example:hello_world_gl --config=for_linux_x64_with_rbe --remote_download_minimal
	bazelisk build //example:hello_world_vulkan --config=for_linux_x64_with_rbe --remote_download_minimal
	bazelisk build //example:hello_world_dawn --config=for_linux_x64_with_rbe --remote_download_minimal
	bazelisk build //example:vulkan_basic --config=for_linux_x64_with_rbe --remote_download_minimal
	bazelisk build //src/sksl/lex:sksllex --config=for_linux_x64_with_rbe --remote_download_minimal
	bazelisk build //tools/skdiff --config=for_linux_x64_with_rbe --remote_download_minimal
	bazelisk build //tools/skslc --config=for_linux_x64_with_rbe --remote_download_minimal
	bazelisk build //modules/skottie:skottie_tool_cpu --config=for_linux_x64_with_rbe --remote_download_minimal
	bazelisk build //modules/skottie:skottie_tool_gpu --config=for_linux_x64_with_rbe --remote_download_minimal
	## TODO(kjlubick) CanvasKit in release mode (i.e. with Closure) requires
	## https://github.com/emscripten-core/emscripten/pull/16640 to land
	bazelisk build //modules/canvaskit:canvaskit --config=linux_rbe \
		--config=ck_full_webgl2_debug --remote_download_minimal

iwyu_rbe:
	bazelisk build //:skia_public --config=for_linux_x64_with_rbe \
		--config=enforce_iwyu --remote_download_minimal --nobuild_runfile_manifests
	bazelisk build //modules/skottie:skottie_tool_gpu --config=for_linux_x64_with_rbe \
		--config=enforce_iwyu --remote_download_minimal --nobuild_runfile_manifests
	bazelisk build //tests/... --config=for_linux_x64_with_rbe \
		--config=enforce_iwyu --remote_download_minimal --nobuild_runfile_manifests

iwyu:
	bazelisk build //:skia_public --config=enforce_iwyu \
		--nobuild_runfile_manifests
	bazelisk build //modules/skottie:skottie_tool_gpu --config=enforce_iwyu \
		--nobuild_runfile_manifests
	bazelisk build //tests/... --config=enforce_iwyu \
		--nobuild_runfile_manifests

=== bazel/rbe/Makefile ===
LINUX_VERSION=v1

build_linux_container:
	docker build -t gcr.io/skia-public/rbe_linux:${LINUX_VERSION} ./gce_linux_container/

push_linux_container: build_linux_container
	docker push gcr.io/skia-public/rbe_linux:${LINUX_VERSION}

generate_linux_config:
	# If you do not have the rbe_configs_gen executable, see
	# https://github.com/bazelbuild/bazel-toolchains/releases/tag/v5.1.2
	rbe_configs_gen \
		--bazel_version=5.0.0 \
		--toolchain_container=gcr.io/skia-public/rbe_linux@sha256:4f7ea556fbf46f65f0c6a2d65144bbcb1139acc78ef19be4bd4b04dcfa623f18 \
		--output_src_root=../.. \
		--output_config_path=bazel/rbe/gce_linux \
		--exec_os=linux \
		--target_os=linux

=== infra/wasm-common/Makefile ===
gold_docker_image: aggregator
	# Set the build context to the current work dir, so we can copy
	# the built binary to where we need it.
	docker build -t gold-karma-chrome-tests -f ./docker/gold-karma-chrome-tests/Dockerfile .

perf_docker_image: aggregator
	# Set the build context to the current work dir, so we can copy
	# the built binary to where we need it.
	docker build -t perf-karma-chrome-tests -f ./docker/perf-karma-chrome-tests/Dockerfile .

aggregator:
	mkdir -p ./tmp
	CGO_ENABLED=0 GOOS=linux go build -o ./tmp/gold-aggregator -a ./gold/
	mkdir -p ./tmp
	CGO_ENABLED=0 GOOS=linux go build -o ./tmp/perf-aggregator -a ./perf/

# Can check CHROME_VERSION with
# docker run karma-chrome-tests /usr/bin/google-chrome-stable --version
CHROME_VERSION=87.0.4280.88_v2

publish_gold_karma_chrome_tests: gold_docker_image
	docker tag gold-karma-chrome-tests gcr.io/skia-public/gold-karma-chrome-tests:${CHROME_VERSION}
	docker push gcr.io/skia-public/gold-karma-chrome-tests:${CHROME_VERSION}

publish_perf_karma_chrome_tests: perf_docker_image
	docker tag perf-karma-chrome-tests gcr.io/skia-public/perf-karma-chrome-tests:${CHROME_VERSION}
	docker push gcr.io/skia-public/perf-karma-chrome-tests:${CHROME_VERSION}

=== modules/canvaskit/Makefile ===
clean:
	- rm -rf ../../out/canvaskit_wasm
	- rm -rf ./npm_build/bin
	- rm -rf ./build/
	$(MAKE) release

release:
	# Does an incremental build where possible.
	./compile.sh
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm/canvaskit.wasm ./build/

release_cpu:
	# Does an incremental build where possible.
	./compile.sh cpu_only
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm/canvaskit.wasm ./build/

release_webgpu:
	# Does an incremental build where possible.
	./compile.sh use_webgpu
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm/canvaskit.wasm ./build/

release_viewer:
	# Does an incremental build where possible.
	./compile.sh viewer
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm/canvaskit.wasm ./build/

debug:
	# Does an incremental build where possible.
	./compile.sh debug_build
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm_debug/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm_debug/canvaskit.wasm ./build/

debug_cpu:
	# Does an incremental build where possible.
	./compile.sh debug_build cpu_only
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm_debug/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm_debug/canvaskit.wasm ./build/

debug_webgpu:
	# Does an incremental build where possible.
	./compile.sh debug_build use_webgpu
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm_debug/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm_debug/canvaskit.wasm ./build/

debug_viewer:
	# Does an incremental build where possible.
	./compile.sh debug_build viewer
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm_debug/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm_debug/canvaskit.wasm ./build/

profile:
	./compile.sh profiling
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm_profile/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm_profile/canvaskit.wasm ./build/

npm:
	rm -rf ./npm_build/bin
	mkdir -p ./npm_build/bin
	cp ./CHANGELOG.md ./npm_build/

	mkdir -p ./npm_build/bin/full
	./compile.sh release
	cp ../../out/canvaskit_wasm/canvaskit.js       ./npm_build/bin/full
	cp ../../out/canvaskit_wasm/canvaskit.wasm     ./npm_build/bin/full

	# These features are turned off to keep code size smaller for the
	# general use case.
	./compile.sh release no_skottie no_particles no_rt_shader no_sksl_trace no_alias_font \
		no_effects_deserialization no_encode_jpeg no_encode_webp legacy_draw_vertices \
		no_embedded_font
	cp ../../out/canvaskit_wasm/canvaskit.js       ./npm_build/bin
	cp ../../out/canvaskit_wasm/canvaskit.wasm     ./npm_build/bin

	mkdir -p ./npm_build/bin/profiling
	./compile.sh profiling
	cp ../../out/canvaskit_wasm_profile/canvaskit.js       ./npm_build/bin/profiling
	cp ../../out/canvaskit_wasm_profile/canvaskit.wasm     ./npm_build/bin/profiling

gm_tests_debug:
	./compile_gm.sh debug
	- rm -rf build/
	mkdir build
	cp ../../out/wasm_gm_tests_debug/wasm_gm_tests.js       ./build
	cp ../../out/wasm_gm_tests_debug/wasm_gm_tests.wasm     ./build

gm_tests:
	./compile_gm.sh
	- rm -rf build/
	mkdir build
	cp ../../out/wasm_gm_tests/wasm_gm_tests.js       ./build
	cp ../../out/wasm_gm_tests/wasm_gm_tests.wasm     ./build

single-gm:
	echo "Go check out http://localhost:8000/wasm_tools/gms.html"
	python3 ../../tools/serve_wasm.py

local-example:
	echo "Go check out http://localhost:8000/npm_build/example.html"
	python3 ../../tools/serve_wasm.py

test-continuous:
	echo "Assuming npm ci has been run by user"
	echo "Also assuming make debug or release has also been run by a user (if needed)"
	npx karma start ./karma.conf.js --no-single-run --watch-poll

test-continuous-headless:
	npx karma start ./karma.conf.js --no-single-run --watch-poll --headless

node-example:
	node ./npm_build/node.example.js --expose-wasm

docker-compile:
	mkdir -p ${SKIA_ROOT}/out/canvaskit_wasm_docker
	docker run --rm --volume ${SKIA_ROOT}:/SRC \
               --volume ${SKIA_ROOT}/out/canvaskit_wasm_docker:/OUT \
               gcr.io/skia-public/canvaskit-emsdk:2.0.0_v1 \
               /SRC/infra/canvaskit/build_canvaskit.sh

typecheck:
	echo "Make sure you've run cd npm_build && npm ci recently"
	cd npm_build && npm run dtslint

bazel_canvaskit_debug:
	bazelisk build :canvaskit --config=ck_full_webgl2_debug
	- rm -rf build/
	mkdir build
	cp ../../bazel-bin/modules/canvaskit/canvaskit/canvaskit.js build/canvaskit.js
	cp ../../bazel-bin/modules/canvaskit/canvaskit/canvaskit.wasm build/canvaskit.wasm

bazel_canvaskit_release:
	bazelisk build :canvaskit --config=ck_full_webgl2_release
	- rm -rf build/
	mkdir build
	cp ../../bazel-bin/modules/canvaskit/canvaskit/canvaskit.js build/canvaskit.js
	cp ../../bazel-bin/modules/canvaskit/canvaskit/canvaskit.wasm build/canvaskit.wasm
	ls -l build

bazel_test_canvaskit:
	bazelisk test :canvaskit_js_tests --config=ck_full_webgl2_release_chrome --test_output=streamed
	echo "test output in //bazel-testlogs/modules/canvaskit/canvaskit_js_tests/test.outputs/"
	cd ../../bazel-testlogs/modules/canvaskit/canvaskit_js_tests/test.outputs/ && unzip -qo outputs.zip && ls

with_debugger:
	# Does an incremental build where possible.
	./compile.sh debug_build enable_debugger
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm_debug/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm_debug/canvaskit.wasm ./build/
	- mkdir ${SKIA_INFRA_ROOT}/debugger-app/wasm_libs/local_build/
	cp ./build/canvaskit.js         ${SKIA_INFRA_ROOT}/debugger-app/wasm_libs/local_build/
	cp ./build/canvaskit.wasm       ${SKIA_INFRA_ROOT}/debugger-app/wasm_libs/local_build/
	cp ./npm_build/types/index.d.ts ${SKIA_INFRA_ROOT}/debugger-app/wasm_libs/local_build/canvaskit.d.ts

with_debugger_release:
	./compile.sh enable_debugger
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm/canvaskit.wasm ./build/
	- mkdir ${SKIA_INFRA_ROOT}/debugger-app/wasm_libs/local_build/
	cp ./build/canvaskit.js         ${SKIA_INFRA_ROOT}/debugger-app/wasm_libs/local_build/
	cp ./build/canvaskit.wasm       ${SKIA_INFRA_ROOT}/debugger-app/wasm_libs/local_build/
	cp ./npm_build/types/index.d.ts ${SKIA_INFRA_ROOT}/debugger-app/wasm_libs/local_build/canvaskit.d.ts

for_shaders:
	./compile.sh
	- rm -rf build/
	mkdir build
	cp ../../out/canvaskit_wasm/canvaskit.js   ./build/
	cp ../../out/canvaskit_wasm/canvaskit.wasm ./build/
	- mkdir ${SKIA_INFRA_ROOT}/shaders/wasm_libs/local_build/
	cp ./build/canvaskit.js         ${SKIA_INFRA_ROOT}/shaders/wasm_libs/local_build/
	cp ./build/canvaskit.wasm       ${SKIA_INFRA_ROOT}/shaders/wasm_libs/local_build/
	cp ./npm_build/types/index.d.ts ${SKIA_INFRA_ROOT}/shaders/wasm_libs/local_build/canvaskit.d.ts

=== third_party/piet-gpu/Makefile ===
debug:
	cd ../externals/piet-gpu/pgpu-render && \
		cargo build --target-dir ../../../piet-gpu/out && \
		cd ../../../piet-gpu

release:
	cd ../externals/piet-gpu/pgpu-render && \
		cargo build --release --target-dir ../../../piet-gpu/out && \
		cd ../../../piet-gpu

=== infra/canvaskit/docker/Makefile ===
EMSDK_VERSION=3.1.3_v1

publish_canvaskit_emsdk:
	docker build -t canvaskit-emsdk ./canvaskit-emsdk/
	docker tag canvaskit-emsdk gcr.io/skia-public/canvaskit-emsdk:${EMSDK_VERSION}
	docker push gcr.io/skia-public/canvaskit-emsdk:${EMSDK_VERSION}

=== PKGBUILD ===
# Maintainer: Naveen M K <naveen521kk at gmail.com>

_realname=skia
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=108.0.5359.95
# blindly follow chromium version number
# see https://omahaproxy.appspot.com/all.json?os=win&channel=stable
# for the commit
_commit="7c55be996a81ff9c5c66984c9d4ef85d12a44c8c"
pkgrel=4
pkgdesc="Skia is a complete 2D graphic library for drawing Text, Geometries, and Images. (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
url="https://skia.org"
msys2_repository_url="https://github.com/google/skia"
license=("spdx:BSD-3-Clause")
makedepends=(
    "${MINGW_PACKAGE_PREFIX}-cc"
    "${MINGW_PACKAGE_PREFIX}-gn"
    "${MINGW_PACKAGE_PREFIX}-ninja"
    "${MINGW_PACKAGE_PREFIX}-pkgconf"
    "${MINGW_PACKAGE_PREFIX}-python"
    "${MINGW_PACKAGE_PREFIX}-expat"
    "${MINGW_PACKAGE_PREFIX}-harfbuzz"
    "${MINGW_PACKAGE_PREFIX}-icu"
    "${MINGW_PACKAGE_PREFIX}-libpng"
    "${MINGW_PACKAGE_PREFIX}-libjpeg-turbo"
    "${MINGW_PACKAGE_PREFIX}-libwebp"
    "${MINGW_PACKAGE_PREFIX}-zlib"
    "git"
)
source=("${_realname}-${pkgver}.tar.gz::https://github.com/google/skia/archive/${_commit}.tar.gz"
    "bare-clones/build::git+https://chromium.googlesource.com/chromium/src/build.git#commit=fd86d60f33cbc794537c4da2ef7e298d7f81138e"
    "0001-Don-t-download-prebuild-gn-and-emsdk.patch"
    "0002-add-mingw-toolchain-skia.patch"
    "0003-fix-dwrite-function-mingw.patch"
    "0004-add-mingw-toolchain-build.patch"
    "0005-dont-undef-CLSID_WICImagingFactory-on-mingw.patch"
    "0006-fix-std-max.patch"
    "0007-delete-experimental-sktext.patch"
    "harfbuzz.gn"
    "icu.gn"
    "zlib.gn"
    "skia.pc"
)
noextract=("${_realname}-${pkgver}.tar.gz")
sha256sums=('48ff8b020d2e54b97ddf7cfc54bb483492aef3dc7b3e61629c8a86bc89995643'
            '96aa5af1b27ec32e2a874b08c7249dcea7289029e035ae58f521d1d22e0ed4b3'
            '5df0992b78f7f6bedba8cef110c73c723513d032015e9b756decb0a06a99a2f6'
            '518166cb8c4848deee114c0f38c0c80289f6d170a31dbaacd0455a573599cd5b'
            '76592221a23555a29debc77df7e2429d52e2b7db1c103e0785bb7a4c669b9e03'
            '63f35c12168fcb5f025db2cb3a4bc693cb4546ce561dc95e45d10c1579daf786'
            '7883ff95984f5eac3002d8205257666f38538e0907046ef17e4850a36103a12c'
            '96b98caea6c426ff0b4f85ced7b45d4b40777396ac7b12bb6490b9d387c1b3c8'
            '43848882c4674b8b520af49cb82e4ea90f1c08c54b899b522d7e099c0e4d566d'
            '7bd0b8cff2f1ec6822c74b731664007f598c3b442718060c499df7ba19141563'
            '36d32b737f87a676f5c4da9b7ae14193e6c1913ddb6508b979effdba2b80ea83'
            'b99874ea904724911528a5530c14f3051c358805bd36df9d205df31458ebf8b9'
            'a5dd30a1b53609aad427945fd119709a899d23a2e9606fbb676c146fdd04e3cd')

apply_patch_with_msg() {
    for _patch in "$@"; do
        msg2 "Applying $_patch"
        patch -Nbp1 -i "${srcdir}/$_patch"
    done
}

prepare() {
    tar -xf "${_realname}-${pkgver}.tar.gz" || true
    mv "${srcdir}/skia-${_commit}" "${srcdir}/skia"

    echo "Syncing all dependencies"
    cd "${srcdir}/skia"
    apply_patch_with_msg \
      0001-Don-t-download-prebuild-gn-and-emsdk.patch
    sed "s|linebender/piet-gpu|linebender/vello|g" -i DEPS
    python "${srcdir}"/skia/tools/git-sync-deps

    echo "Patching build directory"
    cd "${srcdir}"/build
    apply_patch_with_msg 0004-add-mingw-toolchain-build.patch
    #python "${srcdir}"/build/util/lastchange.py -o "${srcdir}"/build/util/LASTCHANGE
    rm -rf "${srcdir}"/skia/build
    ln -sf "${srcdir}"/build "${srcdir}"/skia
    echo "checkout_google_benchmark = false" >"${srcdir}"/skia/build/config/gclient_args.gni

    echo "Preparing Skia Source"
    cd "${srcdir}"/skia
    apply_patch_with_msg \
      0002-add-mingw-toolchain-skia.patch \
      0003-fix-dwrite-function-mingw.patch \
      0005-dont-undef-CLSID_WICImagingFactory-on-mingw.patch \
      0006-fix-std-max.patch
    # Delete experimental/sktext https://github.com/google/skia/commit/4594e2ef
    apply_patch_with_msg \
      0007-delete-experimental-sktext.patch
    rm -r experimental/sktext
    cp "${srcdir}/harfbuzz.gn" "${srcdir}/skia/third_party/harfbuzz/BUILD.gn"
    cp "${srcdir}/icu.gn" "${srcdir}/skia/third_party/icu/BUILD.gn"
    cp "${srcdir}/zlib.gn" "${srcdir}/skia/third_party/zlib/BUILD.gn"

    sed "s/@VERSION@/$pkgver/g" -i "$srcdir/skia.pc"
    sed "s/@CFLAGS@//g" -i "$srcdir/skia.pc"
    sed "s|^prefix=.*|prefix=${MINGW_PREFIX}|g" -i "$srcdir/skia.pc"
}

build() {
    local BUILDTYPE=Release
    if check_option "debug" "y"; then
        BUILDTYPE="Debug"
    fi

    if [[ ${CARCH} == aarch64 ]]; then
        _arch=arm64
    else
        _arch=x64
    fi

    case ${BUILDTYPE} in
    Release)
        _is_official=true
        ;;
    Debug)
        _is_official=false
        ;;
    esac

    if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
        export LD=clang++
        export AR=llvm-ar
    else
        export LD=g++
        export AR=ar
    fi

    cd "${srcdir}"/skia
    ${MINGW_PREFIX}/bin/gn gen "${PWD}/out/${BUILDTYPE}-${MSYSTEM}" --args="
      target_cpu=\"${_arch}\"
      is_official_build=${_is_official}
      cc=\"${CC}\"
      cxx=\"${CXX}\"
      is_component_build=false
      skia_enable_tools=false
      skia_use_system_libjpeg_turbo=true
      skia_use_system_libwebp=true
      skia_use_system_libpng=true
      use_sysroot=false
      skia_use_xps=false"

    ninja -C "${PWD}/out/${BUILDTYPE}-${MSYSTEM}"
}

package() {
    cd "skia"
    local BUILDTYPE=Release
    if check_option "debug" "y"; then
        BUILDTYPE="Debug"
    fi
    ls "${PWD}/out/${BUILDTYPE}-${MSYSTEM}"

    install -d "$pkgdir"/${MINGW_PREFIX}/lib
    install -Dm755 out/${BUILDTYPE}-${MSYSTEM}/*.a "$pkgdir"/${MINGW_PREFIX}/lib/

    install -d "$pkgdir"/${MINGW_PREFIX}/include/skia
    cp --parents `find ./include -name \*.h` "$pkgdir"/${MINGW_PREFIX}/include/skia
    cp --parents `find ./modules -name \*.h` "$pkgdir"/${MINGW_PREFIX}/include/skia

    install -d "$pkgdir"/${MINGW_PREFIX}/lib/pkgconfig
    install -m644 "$srcdir/skia.pc" "$pkgdir"/${MINGW_PREFIX}/lib/pkgconfig/

    install -d "$pkgdir"/${MINGW_PREFIX}/share/licenses/skia
    install -m644 LICENSE* "$pkgdir"/${MINGW_PREFIX}/share/licenses/${_realname}
}
